"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const albacoreInit_1 = require("./albacoreInit");
const albacoreLoad_1 = require("./albacoreLoad");
class Albacore {
    constructor(path) {
        this.path = path;
        let DBexist = fs.existsSync(this.path);
        if (DBexist) {
            albacoreLoad_1.default(this);
        }
        else {
            albacoreInit_1.default(this.path);
            albacoreLoad_1.default(this);
        }
    }
    addTable(name) {
        if (this.link[name])
            throw new Error("table already exist");
        let tablePath = this.path + "/" + name;
        this.link[name] = {
            path: tablePath,
            chunk: [tablePath + "/chunk0"],
        };
        fs.writeFileSync(this.path + "/albacore.json", JSON.stringify(this.link));
        fs.mkdirSync(tablePath);
        fs.writeFileSync(tablePath + "/chunk0", "");
        return this;
    }
    writeTable(name, content) {
        if (!this.link[name])
            throw new Error("table not exist");
        let tablePath = this.path + "/" + name;
        if (content instanceof Array || content instanceof Object) {
            content = JSON.stringify(content);
        }
        fs.writeFileSync(tablePath + "/chunk0", content);
        return this;
    }
    table(name, encode) {
        let content = fs.readFileSync(this.link[name].chunk[0], {
            encoding: "utf8",
        });
        return encode ? JSON.parse(content) : content;
    }
    setLink(obj) {
        this.link = obj;
        return this;
    }
    getPath() {
        return this.path;
    }
}
exports.default = Albacore;
//# sourceMappingURL=albacore.js.map